<?php
namespace nulib\db\mysql;

use nulib\db\_private\_migration;

class _mysqlMigration extends _migration {
  static function with($migration): self {
    if ($migration instanceof self) return $migration;
    else return new static($migration);
  }

  const MIGRATION_COLS = [
    "channel" => "varchar(64) not null",
    "name" => "varchar(64) not null",
    "done" => "integer not null default 0",
    "primary key (channel, name)",
  ];

  protected function setMigrated(string $name, bool $done): void {
    $this->db->exec([
      "insert",
      "into" => static::MIGRATION_TABLE,
      "values" => [
        "channel" => $this->channel,
        "name" => $name,
        "done" => $done? 1: 0,
      ],
      "suffix" => "on duplicate key update done = :done",
    ]);
  }
}
