<?php
namespace nulib\db\pgsql;

use nulib\db\_private\_migration;

class _pgsqlMigration extends _migration {
  static function with($migration): self {
    if ($migration instanceof self) return $migration;
    else return new static($migration);
  }

  protected function setMigrated(string $name, bool $done): void {
    $this->db->exec([
      "insert",
      "into" => static::MIGRATION_TABLE,
      "values" => [
        "channel" => $this->channel,
        "name" => $name,
        "done" => $done? 1: 0,
      ],
      "suffix" => "on conflict (channel, name) do update set done = :done",
    ]);
  }
}
