<?php
namespace nulib\file\tab;

use nulib\file\IWriter;

interface IBuilder extends \nulib\file\IReader {
  function writeHeaders(?array $headers=null): void;

  function write(?array $row): void;

  function writeAll(?iterable $rows=null): void;

  /**
   * @return int le nombre de ligne qui ont été écrites (sans compte l'en-tête)
   */
  function getCount(): int;

  /** préparer le fichier (sans l'envoyer) */
  function build(?iterable $rows=null, bool $close=true): bool;

  /** enregistrer le fichier préparé avec {@link build()} */
  function copyTo(IWriter $dest, bool $closeWriter=false, bool $closeReader=true): void;

  /** envoyer les en-têtes */
  function sendHeaders(): void;

  /**
   * envoyer le fichier pour téléchargement (la méthode {@link sendHeaders()}
   * est automatiquement appelée le cas échéant
   */
  function sendFile(?iterable $rows=null): int;
}
