<?php
namespace nulib\ref\schema;

class ref_input {
  const ACCESS_AUTO = 0, ACCESS_KEY = 1, ACCESS_PROPERTY = 2;

  const INPUT_PARAMS_SCHEMA = [
    "access_type" => ["int", self::ACCESS_AUTO, "type d'accès: clé ou propriété"],
    "allow_empty" => ["bool", true, "la chaine vide est-elle autorisée?"],
    "allow_null" => ["bool", true, "la valeur null est-elle autorisée?"],
  ];

  const ACCESS_PARAMS_SCHEMA = [
    "allow_empty" => ["bool", true, "la chaine vide est-elle autorisée?"],
    "allow_null" => ["bool", null, "la valeur null est-elle autorisée?"],
    "allow_false" => ["bool", null, "la valeur false est-elle autorisée?"],
    "protect_dest" => ["bool", null, "faut-il protéger la destination?"],
  ];

  const VALUE_ACCESS_PARAMS_SCHEMA = [
    "allow_null" => ["bool", false],
    "allow_false" => ["bool", true],
    "protect_dest" => ["bool", false],
  ];

  const ARRAY_ACCESS_PARAMS_SCHEMA = [
    "allow_null" => ["bool", true],
    "allow_false" => ["bool", false],
    "protect_dest" => ["bool", true],
    "key_prefix" => ["?string", null, "préfixe des clés pour les méthodes ensureXxx()"],
    "key_suffix" => ["?string", null, "suffixe des clés pour les méthodes ensureXxx()"],
  ];

  const PROPERTY_ACCESS_PARAMS_SCHEMA = [
    "allow_null" => ["bool", true],
    "allow_false" => ["bool", false],
    "protect_dest" => ["bool", true],
    "key_prefix" => ["?string", null, "préfixe des clés pour les méthodes ensureXxx()"],
    "key_suffix" => ["?string", null, "suffixe des clés pour les méthodes ensureXxx()"],
    "map_names" => ["bool", true, "faut-il mapper les clés en camelCase?"]
  ];
}
